<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%">
      <v-toolbar style="position: relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-link-variant</v-icon
            ><b>{{ linkType }} Link Externo</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon v-on="on" style="position: absolute; right: 15px" color="red" @click="close"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>
      <v-card-text>
        <v-form ref="form">
          <v-container>
            <v-row no-gutters>
              <v-col cols="12" class="mt-n1">
                <v-text-field
                  autofocus
                  class="pr-2"
                  v-model="inputLink.name"
                  label="Nome"
                  prepend-icon="mdi-pencil-box-outline"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  class="pr-2"
                  v-model="inputLink.link"
                  label="URL"
                  prepend-icon="mdi-link"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions class="mt-n3 pb-6 pr-6">
        <v-spacer></v-spacer>
        <v-btn color="primary" text @click="close">Cancelar</v-btn>
        <v-btn
          color="primary"
          elevation="0"
          @click="confirm"
          :disabled="!inputLink.name || !inputLink.link"
          >{{ linkType }}</v-btn
        >
      </v-card-actions>
    </v-card>
  </v-row>
</template>
<script>
import { mapGetters, mapState } from 'vuex'
import CollaborativeWork from '../../services/collaborativeWork'
export default {
  name: 'Links',
  props: {
    linkType: { type: String, default: 'Nome da ação' },
    linkToEdit: {
      type: Object,
      default: () => {},
    },
  },
  data() {
    return {
      inputLink: { name: '', link: 'http://' },
    }
  },
  created() {
    if (this.linkToEdit.id) {
      this.inputLink.name = this.linkToEdit.name
      this.inputLink.link = this.linkToEdit.link
    }
  },
  computed: {
    checkDialogIsActive() {
      return this.$store.state.user.closeDialog
    },
  },
  watch: {
    checkDialogIsActive() {
      if (this.checkDialogIsActive) {
        this.close()
        this.$store.commit('user/UPDATE_CLOSE_DIALOG', false)
      }
    },
    'linkToEdit.id'() {
      if (this.linkToEdit.id) {
        this.inputLink.name = this.linkToEdit.name
        this.inputLink.link = this.linkToEdit.link
      }
    },
  },
  methods: {
    close() {
      this.inputLink = { name: '', link: 'http://' }
      this.$emit('closeLinkDialog')
    },
    async confirm() {
      let ret
      if (this.linkType == 'Adicionar') ret = await this.addLink()

      if (this.linkType == 'Editar') ret = await this.updateLink()

      this.inputLink = { name: '', link: 'http://' }
      this.$emit('confirmLinkDialog', ret)
    },
    async addLink() {
      let ret
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        let actionId = actionsMap.get('collaborativeWorkUpdate').id
        ret = await CollaborativeWork.addExternalLink(routedEntity.id, actionId, {
          collaborativeWork: this.linkToEdit.collaborativeWorkId,
          externalLink: { name: this.inputLink.name, link: this.inputLink.link },
        })
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      return ret
    },
    async updateLink() {
      let ret
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        let actionId = actionsMap.get('collaborativeWorkUpdate').id
        ret = await CollaborativeWork.updateExternalLink(routedEntity.id, actionId, {
          id: this.linkToEdit.collaborativeWorkId,
          linkId: this.linkToEdit.id,
          update: {
            name: this.inputLink.name,
            link: this.inputLink.link,
          },
        })
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      return ret
    },
  },
}
</script>
